import * as Parser from '@anycli/parser';
import * as Config from '.';
export interface Command {
    id: string;
    hidden: boolean;
    aliases: string[];
    description?: string;
    title?: string;
    usage?: string | string[];
    examples?: string[];
    type?: string;
    flags: {
        [name: string]: Command.Flag.Boolean | Command.Flag.Option;
    };
    args: {
        name: string;
        description?: string;
        required?: boolean;
        hidden?: boolean;
        default?: string;
        options?: string[];
    }[];
}
export declare namespace Command {
    namespace Flag {
        interface Boolean {
            type: 'boolean';
            name: string;
            required?: boolean;
            char?: string;
            hidden?: boolean;
            description?: string;
        }
        interface Option {
            type: 'option';
            name: string;
            required?: boolean;
            char?: string;
            hidden?: boolean;
            description?: string;
            helpValue?: string;
            default?: string;
            options?: string[];
        }
    }
    interface Base {
        _base: string;
        id: string;
        hidden: boolean;
        aliases: string[];
        description?: string;
        title?: string;
        usage?: string | string[];
        examples?: string[];
    }
    interface Full extends Base {
        plugin?: Config.IPlugin;
        flags?: Parser.flags.Input<any>;
        args?: Parser.args.Input;
        new <T>(argv: string[], config?: Config.Options): T;
        run(argv: string[], config?: Config.Options): Promise<any>;
    }
    interface Plugin extends Command {
        load(): Full;
    }
    function toCached(c: Full): Command;
}
