"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cli_ux_1 = require("cli-ux");
const globby = require("globby");
const _ = require("lodash");
const path = require("path");
const Config = require(".");
const debug = require('debug')('@anycli/config');
var Manifest;
(function (Manifest) {
    function build(version, dir, findCommand) {
        debug(`loading IDs from ${dir}`);
        const ids = globby.sync(['**/*.+(js|ts)', '!**/*.+(d.ts|test.ts|test.js)'], { cwd: dir })
            .map(file => {
            const p = path.parse(file);
            const topics = p.dir.split('/');
            let command = p.name !== 'index' && p.name;
            return _([...topics, command]).compact().join(':');
        });
        debug('found ids', ids);
        let commands = ids.map(id => {
            try {
                return [id, Config.Command.toCached(findCommand(id))];
            }
            catch (err) {
                cli_ux_1.default.warn(err);
            }
        });
        return {
            version,
            commands: _(commands)
                .compact()
                .fromPairs()
                .value()
        };
    }
    Manifest.build = build;
})(Manifest = exports.Manifest || (exports.Manifest = {}));
